Subject: Re: [RFC PATCH v2 07/11] notes: implement helpers needed for note copying during rewrite

From: Thomas Rast <[email-masked]>
Date: Wed, 17 Feb 2010 01:09:24 +0100

On Wednesday 17 February 2010 00:58:18 Junio C Hamano wrote:
> Thomas Rast <[email-masked]> writes:
> 
> > Implement helper functions to load the rewriting config, and to
> > actually copy the notes.  Also document the config.
> 
> I find it somewhat unnerving that this series is a bit overengineered to
> have fancier and facier handling of notes, while at the same time still
> sticking to the "only one default notes tree" mode of operation.  Are you
> digging a deep hole that you will find hard to get out of when you finally
> need to support copying/rewriting notes from multiple trees at the same
> time?

Hmm, very good point.

I believe the code in this patch is fairly well-prepared to deal with
it.  It would merely need to learn to store a list of trees in the
notes_rewrite_cfg, provided that it's ok to load them all
simultaneously.

However, I haven't really thought about having several notes trees.
Is this automatic copying the only operation that needs this feature,
or were you thinking of others too?  Is it enough to, say, introduce a
way of configuring it at the branch level, or declaring that we
rewrite everything in refs/notes, or some such?

-- 
Thomas Rast
trast@{inf,student}.ethz.ch